Package: GIGSEA
Type: Package
Title: Genotype Imputed Gene Set Enrichment Analysis
Version: 1.29.0
Author: Shijia Zhu
Maintainer: Shijia Zhu <shijia.zhu@mssm.edu>
Description: We presented the Genotype-imputed Gene Set Enrichment Analysis (GIGSEA), a novel method that uses GWAS-and-eQTL-imputed trait-associated differential gene expression to interrogate gene set enrichment for the trait-associated SNPs. By incorporating eQTL from large gene expression studies, e.g. GTEx, GIGSEA appropriately addresses such challenges for SNP enrichment as gene size, gene boundary, SNP distal regulation, and multiple-marker regulation. The weighted linear regression model, taking as weights both imputation accuracy and model completeness, was used to perform the enrichment test, properly adjusting the bias due to redundancy in different gene sets. The permutation test, furthermore, is used to evaluate the significance of enrichment, whose efficiency can be largely elevated by expressing the computational intensive part in terms of large matrix operation. We have shown the appropriate type I error rates for GIGSEA (<5%), and the preliminary results also demonstrate its good performance to uncover the real signal. 
License: LGPL-3
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5), Matrix, MASS, locfdr, stats, utils
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
RoxygenNote: 6.0.1
NeedsCompilation: no
biocViews:
        GeneSetEnrichment,SNP,VariantAnnotation,GeneExpression,GeneRegulation,Regression,DifferentialExpression
git_url: https://git.bioconductor.org/packages/GIGSEA
git_branch: devel
git_last_commit: 456186a
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
Packaged: 2025-10-30 21:23:31 UTC; biocbuild

# GIGSEA
Genotype Imputed Gene Set Enrichment Analysis using GWAS Summary Level Data

## Description
Various methods of gene set analysis for trait-associated SNPs have been 
proposed, however, many challenges and limitations remained: 
1. Gene boundaries: different criteria have been proposed to assign a SNP to 
a gene but no consensus was reached; 
2. Long-range regulation: assigning a causal link to the gene nearest the 
associated variant falls short of elucidating long-range functional connection; 
3. Gene size: longer genes are more likely to have significant P-values, 
possibly inflating the association test for gene sets that have many long genes; 
4. Multiple-marker regulation: the best strategy is not determined on the number 
of SNPs for each gene and aggregation of different effect sizes of SNPs; 
5. Linkage disequilibrium (LD): the local LD may reduce power to detect 
associations dependent on multiple markers. 
6. Redundancy among gene sets: a gene may function in multiple ways and thus 
appear multiple times in functional gene sets. In spite of reflecting the 
crosstalk between gene sets, the overlap in gene sets may make the results of 
gene set enrichment analysis more difficult to interpret; 
7. Permutation efficiency: the computational burden of permutation can be 
substantial; 
8. Threshold-selection: a threshold-dependent procedure may cause the 
instability of results. 

Here, we present GIGSEA (Genotype Imputed Gene Set Enrichment Analysis), a novel 
method that uses GWAS summary statistics and eQTL to infer differential gene 
expression and interrogate gene set enrichment for the trait-associated SNPs. 
By incorporating empirical eQTL of disease-relevant tissue, GIGSEA naturally 
accounts for factors such as gene size, gene boundary, SNP distal regulation, 
and multiple-marker regulation. The weighted linear regression model was used 
to perform the enrichment test, properly adjusting imputation accuracy, model incompleteness and redundancy in different gene sets. The significance level of 
enrichment is assessed by permutation, where matrix operation was employed to 
dramatically improve computation speed and efficiency. We have shown GIGSEA has 
appropriate type I error, and demonstrated high computational efficiency on real 
data set and discovered the plausible biological findings. 


## Dependencies on R packages
-  Matrix - [Matrix](https://cran.r-project.org/web/packages/Matrix/index.html)
-  locfdr - [locfdr](https://cran.r-project.org/web/packages/locfdr/index.html)

## Installation:
1. Install GIGSEA R package from [devtools](https://github.com/hadley/devtools) package in R
```
> install.packages("devtools")
> library(devtools) 
> install_github("zhushijia/GIGSEA")
```
2. Install [MetaXcan](https://github.com/hakyimlab/MetaXcan) package in Python


## Example:
  See [Tutorial](https://github.com/zhushijia/GIGSEA/blob/master/vignettes/GIGSEA_tutorial.Rmd)

#' permutationSimpleLm
#'
#' permutationSimpleLm is a permutation test to calculate the empirical p 
#' values for a weighted simple linear regression.
#'
#' @param fc a vector of numeric values representing the gene expression fold 
#' change
#' @param net a matrix of numeric values in the size of gene number x gene set 
#' number, representing the connectivity betweeen genes and gene sets
#' @param weights a vector of numeric values representing the weights of 
#' permuted genes
#' @param num a vector of integer values representing the number of 
#' permutations
#' @param verbose an boolean value indicating whether or not to print output to 
#' the screen 
#'
#' @return a data frame comprising the following columns:
#' \itemize{
#' \item {term} a vector of character values incidating the name of gene set.
#' \item {usedGenes} a vector of numeric values indicating the number of genes 
#' used in the model.
#' \item {Estimate} a vector of numeric values indicating the regression 
#' coefficients.
#' \item {Std..Error} a vector of numeric values indicating the standard 
#' errors of regression coefficients.
#' \item {t.value} a vector of numeric values indicating the t-statistics of 
#' regression coefficients.
#' \item {observedPval} a vector of numeric values [0,1] indicating the p 
#' values from weighted simple regression model.
#' \item {empiricalPval} a vector of numeric values [0,1] indicating the 
#' empirical p values from the permutation test.
#' }
#'
#'
#' @export
#'
#' @examples
#'
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of gene differential expression, which 
#' # follows the normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use as weights the prediction R^2 and the fraction of imputation-used SNPs 
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted linear regression-based 
#' # enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the permuted genes with the gene sets of interest
#' data2 <- orderedIntersect( x = data , by.x = data$gene , 
#' by.y = rownames(net)  )
#' net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
#' by.y = data$gene  )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' # the SGSEA.res1 uses the weighted simple linear regression model, 
#' # while SGSEA.res2 used the weighted Pearson correlation. The latter one 
#' # takes substantially less time.
#' # system.time(SGSEA.res1<-permutationSimpleLm(fc=data2$fc, net=net2, 
#' # weights=data2$weights, num=1000))
#' # system.time(SGSEA.res2<-permutationSimpleLmMatrix(fc=data2$fc, net=net2, 
#' # weights=data2$weights, num=1000))
#' # head(SGSEA.res2)
#' 
#' 
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @seealso \code{\link{orderedIntersect}}; 
#' \code{\link{permutationSimpleLmMatrix}};
#'
permutationSimpleLm <- function( fc, net, weights=rep(1,nrow(net)), 
                                 num=100, verbose=TRUE )
{
    shuffledPval <- lapply( seq_len(num) , function(i) {
        if(verbose) reportProgress(i,num,10)
        shuffledFC <- sample(fc,length(fc))
        separateLm( shuffledFC , net , weights )
   })
   
    shuffledPval <- do.call( cbind , shuffledPval )
    observedPval <- separateLm( fc , net , weights )
    
    empiricalPval <- vector("numeric", nrow(shuffledPval))
    for(i in seq_len(nrow(shuffledPval)) )
    {
        empiricalPval[i] <- mean( shuffledPval[i,]<observedPval[i] )
    }
    
    term <- colnames(net)
    usedGenes <- apply(as.matrix(net), 2, function(x) sum(x!=0,na.rm=TRUE) )
    pval <- data.frame( term , usedGenes , observedPval , empiricalPval )
    rownames(pval) <- NULL
    pval <- pval[order(pval$empiricalPval),]
    pval
}


separateLm <- function( y , net , weights )
{
    apply( net , 2 , function(x) {
        z <- lm( y~x , weights=weights )
        summary(z)$coef[-1,4]
  })
}

reportProgress <- function(current, total, percent.text = 10, percent.dot = 2){
  
    all.iterations <- seq_len(total)
    percent.prog <- round(all.iterations/total, 2)*100
    
    rounded.percent.write <- percent.prog%/%percent.text
    rounded.percent.dot <- percent.prog%/%percent.dot
    
    current.locale <- which(all.iterations == current)
    current.percent.write <- rounded.percent.write[current.locale]
    current.percent.dot <- rounded.percent.dot[current.locale]
    
    curr.percent.write.locale <- 
        which(rounded.percent.write==current.percent.write)
    curr.percent.dot.locale<-which(rounded.percent.dot==current.percent.dot)
    
    
    if(current.locale == min(curr.percent.write.locale)){
        cat(rounded.percent.write[current.locale]*percent.text, "%.", sep = "")
    } else {
        if(current.locale == min(curr.percent.dot.locale)){
            cat(".")
        }
    }
}

#' weightedGSEA
#'
#' weightedGSEA performs both SGSEA and MGSEA for a given list of gene sets, 
#' and writes out the results.
#'
#' @param data a data frame comprising comlumns: gene names (characer), 
#' differential gene expression (numeric) and permuated gene weights (numeric 
#' and optional)
#' @param geneCol an integer or a character value indicating the column of gene 
#' name
#' @param fcCol an integer or a character value indicating the column of 
#' differential gene expression
#' @param weightCol an integer or a character value indicating the column of 
#' gene weights
#' @param geneSet a vector of character values indicating the gene sets of 
#' interest. 
#' @param permutationNum an integer value indicating the number of permutation
#' @param outputDir a character value indicating the directory for saving the 
#' results
#' @param MGSEAthres an integer value indicating the thresfold for MGSEA. MGSEA 
#' is performed with no more than "MGSEAthres" gene sets 
#' @param verbose an boolean value indicating whether or not to print output to 
#' the screen 
#' 
#' 
#' @return TRUE
#' @export
#'
#' @examples
#'
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#' fc <- heart.metaXcan$zscore
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#' data <- data.frame(gene,fc,weights)
#' # run one-step GIGSEA 
#' # weightedGSEA(data, geneCol='gene', fcCol='fc', weightCol= 'weights', 
#' #    geneSet=c("MSigDB.KEGG.Pathway","MSigDB.TF","MSigDB.miRNA",
#' # "TargetScan.miRNA"), permutationNum=10000, outputDir="./GIGSEA" )
#' # dir("./GIGSEA")
#' 
weightedGSEA <- function( data , geneCol , fcCol , weightCol=NULL ,
                        geneSet=c("MSigDB.KEGG.Pathway","MSigDB.TF",
                                  "MSigDB.miRNA","TargetScan.miRNA") ,
                        permutationNum=100 , outputDir=getwd() , 
                        MGSEAthres = NULL , verbose = TRUE )
{
  
    if( !file.exists(outputDir) )
    { 
        if( verbose ) message('creating ' , outputDir )
        dir.create( outputDir , showWarnings = TRUE, recursive = TRUE) 
    }
    
    allGeneSet <- c("MSigDB.KEGG.Pathway","MSigDB.TF","MSigDB.miRNA",
                    "Fantom5.TF","TargetScan.miRNA","GO","LINCS.CMap.drug")
    noGeneSet <- setdiff( geneSet , allGeneSet )
    if( length(noGeneSet)>0 & verbose ) 
        message( "Gene sets are not defined: ", noGeneSet )
    
    for( gs in intersect(geneSet,allGeneSet) )
    {
        if( verbose ) message('\n\n*** Checking',gs,'...')
        data(list=gs)
        net <- get(gs)$net
        net <- net[ rownames(net) %in% as.character(data[,geneCol]) , ]
        imputeFC <- data[ match(rownames(net),as.character(data[,geneCol])), ]
        fc <- imputeFC[,fcCol]
        
        if( is.null(weightCol) )
        {
            weights <- rep(1, nrow(net))
        } else {
            weights <- imputeFC[,weightCol]
        }
        
        if( verbose ) message('--> performing SGSEA ...')
        SGSEA.res <- permutationSimpleLmMatrix( fc , net , weights , 
                                                permutationNum )
        if( !is.null(get(gs)$annot) )
        {
            annot <- get(gs)$annot
            if( all(table(annot[,1])==1) )
            SGSEA.res <- merge( annot , SGSEA.res , by.x=colnames(annot)[1] ,
                                by.y=colnames(SGSEA.res)[1] )
        }
        SGSEA.res <- SGSEA.res[order(SGSEA.res$empiricalPval) , ]
        write.table( SGSEA.res , paste0(outputDir,'/',gs,'.SGSEA.txt') , 
                     sep='\t' , quote=FALSE , row.names=FALSE , col.names=TRUE)
        
        if( !is.null(MGSEAthres) )
        {
            if( ncol(net)<MGSEAthres )
            {
                if( verbose ) message('\n--> performing MGSEA ...')
                MGSEA.res <- permutationMultipleLmMatrix( fc , net , weights , 
                                                    permutationNum )
                if( !is.null(get(gs)$annot) )
                {
                    annot <- get(gs)$annot
                    if( all(table(annot[,1])==1) )
                    MGSEA.res <- merge( annot , MGSEA.res , 
                                        by.x=colnames(annot)[1] , 
                                        by.y=colnames(MGSEA.res)[1] )
                }
                MGSEA.res <- MGSEA.res[order(MGSEA.res$empiricalPval) , ]
                write.table( MGSEA.res, paste0(outputDir,'/',gs,'.MGSEA.txt'), 
                             sep='\t' , quote=FALSE , row.names=FALSE , 
                             col.names=TRUE)
            }
        }
    }
    
    return(TRUE)
    
}

#' weightedMultipleLm
#'
#' weightedMultipleLm solves the weighted multiple linear regression model via 
#' matrix operation
#'
#' @param x a matrix of numeric values in the size of genes x featureA
#' @param y a matrix of numeric values in the size of genes x featureB
#' @param w a vector of numeric values indicating the weights of genes
#'
#' @return a matrix of numeric values in the size of featureA*featureB, 
#' indicating the weighted multiple regression coefficients
#' @export
#'
#' @examples
#'
#'
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of gene differential expression, which follows 
#' # the normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use as weights the prediction R^2 and the fraction of imputation-used SNPs 
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted linear regression-based 
#' # enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the permuated genes with the gene sets of interest
#' data2 <- orderedIntersect( x = data , by.x = data$gene , 
#' by.y = rownames(net)  )
#' net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
#' by.y = data$gene  )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' # perform the weighted multiple linear regression 
#' observedTstats = weightedMultipleLm( x=net2 , y=data2$fc, w=data2$weights )
#'
#' # calculate the p values of the weighted multiple regression coefficients
#' observedPval = 2 * pt(abs(observedTstats), df=sum(weights>0,na.rm=TRUE)-2, 
#' lower.tail=FALSE)
#'
#' res = data.frame( observedTstats , observedPval )
#' head(res)
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @seealso \code{\link{orderedIntersect}}; \code{\link{matrixPval}};
#'
weightedMultipleLm <- function( x, y, w=rep(1,nrow(x))/nrow(x) )
{
    #library(MASS)
    x <- as.matrix(x)
    y <- as.matrix(y)
    x[is.na(x)] <- 0
    y[is.na(y)] <- 0
    w[is.na(w)] <- 0
    X <- cbind(1,x)
    W <- diag(w)
    #A <- solve(t(X) %*% W %*% X)
    A <- ginv(t(X) %*% W %*% X)
    B <- t(X) %*% W %*% y
    coefs <- A %*% B
    predicts <- X %*% coefs
    residuals <- y - predicts
    #delta <- colSums( w * residuals^2 )/( sum(w>0,na.rm=T)-ncol(X) )
    delta <- colSums( w * residuals^2 )/( sum(w>0,na.rm=TRUE)-qr(X)$rank )
    se <- vapply( delta , function(d) sqrt( d * diag(A) ) , numeric(nrow(A)) )
    t <- coefs/se
    as.matrix(t[-1,])
}

#' dataframe2geneSet
#'
#' dataframe2geneSet transforms a data frame (1term-1gene) into geneSets 
#' (1term-Ngenes).
#'
#' @param term a character value incidating the name of the column for the 
#' gene set (terms).
#' @param gene a character value incidating the name of the column for the 
#' genes.
#' @param value a vector of numeric values indicating the connectivity of 
#' between terms and genes. It could take either discrete values (0 and 1) 
#' or continuous values.
#'
#' @return a data frame, comprising three vectors: term (like pathway names), 
#' geneset (a gene symbol list separate by comma), and value (either discrete 
#' or continuous separated by comma)
#' 
#' @export
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#'
#' @seealso \code{\link{geneSet2Net}}; \code{\link{geneSet2sparseMatrix}};
#'
dataframe2geneSet <- function( term , gene , value=NULL )
{
    if( is.null(value) )
    {
        geneset <- split( gene , term )
        geneset <- vapply( geneset, function(x) 
            paste(x,collapse=','), character(1) )
        res <- data.frame( term=names(geneset) , geneset=geneset )
    } else {
        gene_value <- paste( gene , value )
        gene_value_set <- split( gene_value , term )
        geneset <- vapply( gene_value_set , function(x) {
            genes <- vapply( strsplit(x,' '), function(gv) gv[1], character(1)) 
            paste(genes,collapse=',')
            } , character(length(gene_value_set)) )
        valueset <- vapply( gene_value_set , function(x) {
            values <- vapply( strsplit(x,' '), function(gv) gv[2], character(1))
            paste( values , collapse=',' )
            } , character(length(gene_value_set)) )
        res <- data.frame( term=names(geneset) , geneset=geneset , 
                        valueset=valueset )
        }
    rownames(res) <- NULL
    res
    
}

#' matrixPval
#'
#' matrixPval calculates the p values for the correlation coefficients based on 
#' t-statistics
#'
#' @param r a vector or a matrix of Pearson correlation coefficients taking 
#' values in [-1,+1]
#' @param df the degree of freedom
#'
#' @return a vector or matrix of p values taking values in [0,1]
#' @export
#'
#' @examples
#'
#' 
#' r <- cor(USArrests)
#' df <- nrow(USArrests) - 2
#' pval1 <- matrixPval(r,df)
#'
#' pval2 <- matrix(ncol=ncol(USArrests),nrow=ncol(USArrests),data=0)
#' for(i in 1:ncol(USArrests))
#' {
#'    for(j in 1:ncol(USArrests))
#'    {
#'      pval2[i,j] <- cor.test(USArrests[,i],USArrests[,j])$p.val
#'    }
#' }
#'
#' head(pval1)
#' head(pval2)
#'
#'
matrixPval <- function(r,df)
{
    t <- sqrt(df)*abs(r) / sqrt(1-r^2)
    2 * pt(t,df,lower.tail=FALSE)
}

#' heart.metaXcan
#'
#' The MetaXcan-predicted differential gene expression from the cardiovascular 
#' disease (CVD) GWAS, CARDIoGRAMplusC4D (60,801 cases, 123,504 controls and 
#' 9.4M SNPs). 
#'
#' @format A data frame with the following items:
#' \describe{
#'   \item{gene}{a gene's id}
#'   \item{gene_name}{a gene's name}
#'   \item{zscore}{MetaXcan's association result for the gene}
#'   \item{effect_size}{MetaXcan's association effect size for the gene}
#'   \item{pvalue}{P-value of the aforementioned statistic}
#'   \item{pred_perf_r2}{R2 of transcriptome prediction model's correlation 
#'   to gene's measured transcriptome}
#'   \item{pred_perf_pval}{pval of transcriptome prediction model's correlation 
#'   to gene's measured transcriptome}
#'   \item{pred_perf_qval}{qval of transcriptome prediction model's correlation 
#'   to gene's measured transcriptome}
#'   \item{n_snps_used}{number of snps from GWAS that got used in MetaXcan 
#'   analysis}
#'   \item{n_snps_in_cov}{number of snps in the covariance matrix}
#'   \item{n_snps_in_model}{number of snps in the prediction model}
#'   \item{var_g}{variance of the gene expression}
#'   ...
#' }
#' @source \url{http://www.cardiogramplusc4d.org/data-downloads/;
#' https://cloud.hakyimlab.org/s-predixcan}
"heart.metaXcan"


#' MSigDB.KEGG.Pathway
#'
#' Gene sets derived from the KEGG pathway database. 
#'
#' @format A list with two items:
#' \describe{
#'   \item{net}{a sparse matrix, the connectivity between terms and genes, 
#'   comprising 186 pathways (column) and 5267 genes (row)}
#'   \item{annot}{a data frame, description of terms}
#'   ...
#' }
#' @source \url{software.broadinstitute.org/gsea/msigdb/collections.jsp#C2}
"MSigDB.KEGG.Pathway"


#' MSigDB.TF
#'
#' Gene sets that share upstream cis-regulatory motifs which can function as 
#' potential transcription factor binding sites.
#'
#' @format A list with two items:
#' \describe{
#'   \item{net}{a sparse matrix, the connectivity between terms and genes, 
#'   comprising 615 TFs (column) and 12774 genes (row)}
#'   \item{annot}{a data frame, description of terms}
#'   ...
#' }
#' @source \url{software.broadinstitute.org/gsea/msigdb/collections.jsp#C3}
"MSigDB.TF"


#' MSigDB.miRNA
#'
#' Gene sets that contain genes sharing putative target sites (seed matches) 
#' of human mature miRNA in their 3'-UTRs.
#'
#' @format A list with two items:
#' \describe{
#'   \item{net}{a sparse matrix, the connectivity between terms and genes, 
#'   comprising 221 miRNAs (column) and 7444 genes (row)}
#'   \item{annot}{a data frame, description of terms}
#'   ...
#' }
#' @source \url{software.broadinstitute.org/gsea/msigdb/collections.jsp#C3}
"MSigDB.miRNA"


#' TargetScan.miRNA
#'
#' Gene sets of predicted human miRNA targets were obtained from TargetScan. 
#' TargetScan groups miRNAs that have identical subsequences at positions 2 
#' through 8 of the miRNA, i.e. the 2-7 seed region plus the 8th nucleotide, 
#' and provides predictions for each such seed motif.  
#'
#' @format A list with two items:
#' \describe{
#'   \item{net}{a sparse matrix, the connectivity between terms and genes, 
#'   comprising 87 miRNA seed motifs and 9861 genes}
#'   \item{annot}{a data frame, description of terms}
#'   ...
#' }
#' @source \url{http://www.targetscan.org}
"TargetScan.miRNA"

#' runGIGSEA
#'
#' runGIGSEA use MetaXcan to impute the trait-associated differential gene 
#' expression from GWAS summary and eQTL database first, and next, performs 
#' gene set enrichment analysis for the trait-associated SNPs. 
#'
#' @param MetaXcan a character value indicating the path to the MetaXcan.py 
#' file.
#' @param model_db_path a character value indicating the path to tissue 
#' transriptome model.
#' @param covariance a character value indicating the path to file containing 
#' covariance information. This covariance should have information related to 
#' the tissue transcriptome model.
#' @param gwas_folder a character value indicating the folder containing GWAS 
#' summary statistics data.
#' @param gwas_file_pattern a regular expression indicating the gwas summary 
#' files.
#' @param snp_column a character value indicating the name of column holding 
#' SNP data, by default, "SNP".
#' @param non_effect_allele_column a character value indicating the name of 
#' column holding "other/non effect" allele data, by default, "A2".
#' @param effect_allele_column a character value indicating the name of column 
#' holding effect allele data, by default, "A1".
#' @param or_column a character value indicating the name of column holding Odd 
#' Ratio data, by default, "OR".
#' @param beta_column a character value indicating the name of column holding 
#' beta data, by default, "BETA".
#' @param beta_sign_column a character value indicating the name of column 
#' holding sign of beta, by default, "direction".
#' @param zscore_column a character value indicating the name of column holding 
#' zscore of beta, by default, "Z".
#' @param pvalue_column a character value indicating the name of column holding 
#' p-values data, by default, "P".
#' @param gene_set a vector of characters indicating the gene sets of interest 
#' for enrichment test, by default, c("MSigDB.KEGG.Pathway","MSigDB.TF",
#' "MSigDB.miRNA","Fantom5.TF","TargetScan.miRNA","GO", "LINCS.CMap.drug")
#' @param permutation_num an integer indicating the number of permutation.
#' @param output_dir a character value indicating the directory for saving the 
#' results.
#' @param MGSEA_thres an integer value indicating the thresfold for performing 
#' MGSEA. When the number of gene sets is smaller than MGSEAthres, we perform 
#' MGSEA.
#' @param verbose an boolean value indicating whether or not to print output to 
#' the screen 
#'
#' @return TRUE
#' @export
#'
#' @examples
#' # runGIGSEA( MetaXcan="/MetaXcan/software/MetaXcan.py" , 
#'   # model_db_path="data/DGN-WB_0.5.db" ,
#'   # covariance="data/covariance.DGN-WB_0.5.txt.gz" ,
#'   # gwas_folder="data/GWAS" ,
#'   # gwas_file_pattern="heart.summary" ,
#'   # zscore_column="Z" ,
#'   # output_dir="./GIGSEA",
#'   # permutation_num=1000)
#'  
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @references 
#' Barbeira, A., et al. Integrating tissue specific mechanisms into GWAS 
#' summary results. bioRxiv 2016:045260.
#' https://github.com/hakyimlab/MetaXcan
#' 
#' @seealso \code{\link{weightedGSEA}}; 
#' 
runGIGSEA <- function( MetaXcan, 
                       model_db_path, 
                       covariance, 
                       gwas_folder, 
                       gwas_file_pattern, 
                       snp_column="SNP", 
                       non_effect_allele_column="A2", 
                       effect_allele_column="A1", 
                       or_column="OR", 
                       beta_column="BETA", 
                       beta_sign_column="direction", 
                       zscore_column="Z", 
                       pvalue_column="P", 
                       gene_set=c("MSigDB.KEGG.Pathway","MSigDB.TF",
                                  "MSigDB.miRNA","TargetScan.miRNA"), 
                       permutation_num=1000, 
                       output_dir="./GIGSEA", 
                       MGSEA_thres=NULL ,
                       verbose = TRUE )
{
    
    MetaXcanCmd<-paste0( MetaXcan , 
                       " --model_db_path " , model_db_path , 
                       " --covariance " , covariance ,
                       " --gwas_folder " , gwas_folder ,
                       " --gwas_file_pattern " , gwas_file_pattern ,
                       " --snp_column " , snp_column ,
                       " --non_effect_allele_column ", non_effect_allele_column,
                       " --effect_allele_column " , effect_allele_column ,
                       " --or_column " , or_column ,
                       " --beta_column " , beta_column ,
                       " --beta_sign_column " , beta_sign_column ,
                       " --zscore_column " , zscore_column ,
                       " --pvalue_column " , pvalue_column ,
                       " --output_file " , output_dir , "/MetaXcan.res.csv" ) 
      
    if( !file.exists(output_dir) )
    { 
        if(verbose) message('creating ' , output_dir )
        dir.create( output_dir , showWarnings = TRUE, recursive = TRUE) 
    }
    
    if(verbose) message(MetaXcanCmd)
    system2(MetaXcanCmd)
    
    metaXcan <- read.table( paste0(output_dir,"/MetaXcan.res.csv") , 
                              sep=',' , header=TRUE )
    cc <- table( as.character( metaXcan$gene_name ) )
    metaXcan <- subset( metaXcan , 
               ! as.character(metaXcan$gene_name) %in% (names(cc)[cc>1]) )
      
    gene <- metaXcan$gene_name
    fc <- metaXcan$zscore
    usedFrac <- metaXcan$n_snps_used / metaXcan$n_snps_in_cov
    r2 <- metaXcan$pred_perf_r2
    weights <- usedFrac*r2
    data <- data.frame(gene,fc,weights)
    
    if(verbose) message( 'permutation for' , permutation_num , 'times' )
    if(verbose) message( 'writing results at' , output_dir )
    
    weightedGSEA(data, geneCol='gene', fcCol='fc', weightCol= 'weights',
                 geneSet=gene_set, permutationNum=permutation_num, 
                 outputDir=output_dir, MGSEAthres=MGSEA_thres)
    
    return(TRUE)
}

#' geneSet2sparseMatrix
#'
#' geneSet2sparseMatrix transforms gene sets to a sparse matrix, which 
#' represents the connectivity between terms and genes.
#'
#'
#' @param term a vector of character values incidating the names of gene sets, 
#' e.g., pathway names and miRNA names.
#' @param geneset a vector of character values, where each value is a gene list 
#' separated by 'sep'.
#' @param value a vector of numeric values indicating the connectivity of 
#' between terms and genes. It could take either discrete values (0 and 1) or 
#' continuous values.
#' @param sep a character which separates the genes in the geneset.
#'
#' @return
#' a sparse matrix where the column corresponds to the term and the row 
#' corresponds to the geneset.
#'
#' @export
#'
#' @examples
#'
#' # download the gmt file
#' gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
#' 'single_drug_perturbations-v1.0.gmt') ) 
#'
#' # obtain the index of up-regulated and down-regulated gene sets
#' index_up <- grep('-up',gmt)
#' index_down <- grep('-dn',gmt)
#'
#' # transform the gmt file into gene sets. The gene set is a data frame, 
#' # comprising three vectors: 
#' # term (here is drug), geneset (a gene symbol list separate by comma), 
#' # and value (1 and -1 separate by comma)
#' gff_up <- gmt2geneSet( gmt[index_up], termCol=c(1,2), singleValue = 1 )
#' gff_down <- gmt2geneSet( gmt[index_down], termCol=c(1,2), singleValue = -1 )
#'
#' # combine up and down-regulated gene sets, and use 1 and -1 to indicate 
#' # their direction 
#' # extract the drug names
#' term_up<-vapply(gff_up$term, function(x) gsub('-up','',x), character(1))
#' term_down<-vapply(gff_down$term, function(x) gsub('-dn','',x), character(1))
#' all(term_up==term_down)
#'
#' # combine the up-regulated and down-regulated gene names for each 
#' # drug perturbation
#' geneset <- vapply(1:nrow(gff_up),function(i) paste(gff_up$geneset[i],
#' gff_down$geneset[i],sep=','), character(1) )
#' 
#' # use 1 and -1 to indicate the direction of up and down-regulated genes
#' value <- vapply( 1:nrow(gff_up) , function(i) paste(gff_up$value[i],
#' gff_down$value[i],sep=',') , character(1) )
#' 
#' 
#' # transform the gene set into matrix, where the row represents the gene, 
#' # the column represents the drug perturbation, and each entry takes values 
#' # of 1 and -1
#' net1 <- geneSet2Net( term=term_up , geneset=geneset , value=value )
#' # transform the gene set into sparse matrix, where the row represents the 
#' # gene, the column represents the drug perturbation, and each entry takes 
#' # values of 1 and -1
#' net2 <- geneSet2sparseMatrix( term=term_up , geneset=geneset , value=value )
#' tail(net1[,1:30])
#' tail(net2[,1:30])
#' # the size of sparse matrix is much smaller than the matrix
#' format( object.size(net1), units = "auto")
#' format( object.size(net2), units = "auto")
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#'
#' @seealso \code{\link{gmt2geneSet}}; \code{\link{geneSet2Net}};
#'
geneSet2sparseMatrix <- function( term , geneset , value=NULL , sep=',' )
{
    #library(Matrix)
    split_geneset <- strsplit( as.character(geneset) , sep )
    names(split_geneset) <- as.character(term)
    genes <- unique( do.call(c,split_geneset) )
    index <- lapply( split_geneset , function(x) match( x , genes )  )
    num <- vapply(index,length,integer(1))
    i <- do.call(c,index)
    j <- rep( seq_along(term), num )
    if( is.null(value) )
    { 
        net <- sparseMatrix( i , j , x=1 , dims=c(length(genes),length(term)) )
    } else {
        sv_tmp <- strsplit( as.character(value) , sep )
        split_value <- lapply( sv_tmp,  function(x) as.numeric(as.character(x)))
        x <- do.call(c,split_value)
        net <- sparseMatrix( i , j , x=x , dims=c(length(genes),length(term)) )
    }
    colnames(net) <- term
    rownames(net) <- genes
    net <- net[ order(genes) , ]
    net
}

#' orderedIntersect
#'
#' orderedIntersect sorts a data frame based on a given collumn and intersects 
#' with another vector.
#'
#' @param x a data frame
#' @param by.x a vector of character values. The data frame is sorted based on 
#' by.x
#' @param by.y a vector of character values. After being sorted, the rows of x 
#' are further filtered by intersecting by.x with by.y
#'
#' @return a data frame sorted by "by.x" and intersected with "by.y"
#' @export
#'
#' @examples
#'
#'
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of gene differential expression, which follows 
#' # normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use the prediction R^2 and fraction of imputation-used SNPs as weights
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted linear regression-based 
#' # enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the user-provided imputed genes with the gene set of interest
#' data2 <- orderedIntersect( x=data, by.x=data$gene, by.y=rownames(net) )
#' net2 <- orderedIntersect( x=net, by.x=rownames(net), by.y=data$gene )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#'
orderedIntersect <- function(x, by.x, by.y)
{
    by.x <- as.character(by.x)
    by.y <- as.character(by.y)
    x <- x[ by.x %in% by.y , ]
    by.x <- by.x[ by.x %in% by.y ]
    x[order(by.x), ]
}

#' gmt2geneSet
#'
#' gmt2geneSet transforms a gmt format file into geneSets.
#'
#' @param gmt a vector of character values. Each item is a list of words 
#' comprising a term and its corresponding gene set, which are separated by tab.
#' @param termCol an integer value indicating in each item of gmt, which word 
#' is the term , by default, 1.
#' @param nonGeneCol an integer value indicating in each item of gmt, which 
#' words are not the gene set, by default, termCol.
#' @param singleValue a numeric value, which assigns the same value to all 
#' genes in a given gene set. This is useful when combining together the 
#' up-regulated gene sets (regularly, singleValue=1) and the down-regulated 
#' gene sets (regularly, singleValue=-1)
#'
#' @return a data frame, comprising three vectors: term (like pathway names), 
#' geneset (a gene symbol list separate by comma), and value (either discrete 
#' or continuous separated by comma)
#' @export
#'
#' @examples
#'
#' # download the gmt file
#' gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
#' 'single_drug_perturbations-v1.0.gmt') ) 
#'
#' # obtain the index of up-regulated and down-regulated gene sets
#' index_up <- grep('-up',gmt)
#' index_down <- grep('-dn',gmt)
#'
#' # transform the gmt file into gene sets. The gene set is a data frame, 
#' # comprising three vectors: 
#' # term (here is drug), geneset (a gene symbol list separate by comma), 
#' # and value (1 and -1 separate by comma)
#' gff_up <- gmt2geneSet( gmt[index_up], termCol=c(1,2), singleValue = 1 )
#' gff_down <- gmt2geneSet( gmt[index_down], termCol=c(1,2), singleValue = -1 )
#'
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @seealso \code{\link{geneSet2Net}}; \code{\link{geneSet2sparseMatrix}};
#'
gmt2geneSet <- function( gmt, termCol=1, nonGeneCol=termCol, singleValue=NULL )
{
    split_gmt <- strsplit( as.character(gmt) , '\t' )
    term <- vapply( split_gmt , function(x) 
        paste( x[termCol],collapse=',' ) , character(1) )
    geneset <- vapply(split_gmt, function(x) 
        paste(x[-nonGeneCol],collapse=',') , character(1) )
    if( is.null(singleValue) )
    {
        gff <- data.frame(term , geneset , stringsAsFactors = FALSE)
    } else {
        gene_num <- vapply( strsplit(geneset,',') , length , integer(1) )
        value <- vapply( gene_num , function(times) 
            paste( rep(singleValue,times),collapse=',') , character(1) )
        gff <- data.frame(term , geneset , value , stringsAsFactors = FALSE)
    }
    gff
}

#' weightedPearsonCorr
#'
#' weightedPearsonCorr caculates the weighted Pearson correlation
#'
#' @param x a matrix of numeric values in the size of genes x featureA
#' @param y a matrix of numeric values in the size of genes x featureB
#' @param w a vector of numeric values indicating the weights of genes
#'
#' @return a matrix of numeric values in the size of featureA*featureB, 
#' indicating the weighted Pearson correlation coefficients
#' @export
#'
#' @examples
#'
#'
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of gene differential expression, which follows 
#' # the normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use as weights the prediction R^2 and fraction of imputation-used SNPs 
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted simple linear 
#' # regression-based enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the imputed genes with the gene sets of interest
#' data2 <- orderedIntersect( x = data , by.x = data$gene , 
#' by.y = rownames(net)  )
#' net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
#' by.y = data$gene  )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' # calculate the weighted Pearson correlation
#' observedCorr = weightedPearsonCorr( x=net2 , y=data2$fc, w=data2$weights )
#'
#' # calculate the p values of the weighted Pearson correlation
#' observedPval = matrixPval( observedCorr, df=sum(weights>0,na.rm=TRUE)-2 )
#'
#' res = data.frame( observedCorr , observedPval )
#' head(res)
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @seealso \code{\link{orderedIntersect}}; \code{\link{matrixPval}};
#'
weightedPearsonCorr <- function( x, y, w=rep(1,nrow(x))/nrow(x) )
{
    x <- as.matrix(x)
    y <- as.matrix(y)
    x[is.na(x)] <- 0
    y[is.na(y)] <- 0
    w[is.na(w)] <- 0
    w <- w / sum(w)
    x <- sweep(x, 2, colSums(x * w))
    y <- sweep(y, 2, colSums(y * w))
    t(w*x)%*% y / sqrt( colSums(w * x**2) %*% t(colSums(w * y**2)) )
}

#' permutationMultipleLm
#'
#' permutationMultipleLm is a permutation test to calculate the empirical p 
#' values for a weighted multiple linear regression.
#'
#' @param fc a vector of numeric values representing gene expression fold 
#' change
#' @param net a matrix of numeric values in the size of gene number x gene set 
#' number, representing the connectivity between genes and gene sets
#' @param weights a vector of numeric values representing the weights of 
#' permuated genes
#' @param num an integer value representing the number of permutations
#' @param verbose an boolean value indicating whether or not to print output to 
#' the screen 
#' 
#' 
#' @return a data frame comprising the following columns:
#' \itemize{
#' \item {term} a vector of character incidating the names of gene sets.
#' \item {usedGenes} a vector of numeric values indicating the number of genes 
#' used in the model.
#' \item {Estimate} a vector of numeric values indicating the regression 
#' coefficients.
#' \item {Std..Error} a vector of numeric values indicating the standard 
#' errors of regression coefficients.
#' \item {t.value} a vector of numeric values indicating the t-statistics of 
#' regression coefficients.
#' \item {observedPval} a vector of numeric values [0,1] indicating the p 
#' values from the multiple weighted regression model.
#' \item {empiricalPval} a vector of numeric values [0,1] indicating the 
#' empirical p values from the permutation test.
#' }
#'
#' @export
#'
#' @examples
#' 
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of differential gene expression, which follows 
#' # the normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use as weights the prediction R^2 and the fraction of imputation-used SNPs 
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted linear regression-based 
#' # enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the imputed genes with the gene sets of interest
#' data2 <- orderedIntersect( x = data , by.x = data$gene , 
#' by.y = rownames(net)  )
#' net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
#' by.y = data$gene  )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' # the MGSEA.res1 uses the weighted multiple linear regression to do 
#' # permutation test, 
#' # while MGSEA.res2 used the solution of weighted matrix operation. The 
#' # latter one takes substantially less time.
#' # system.time( MGSEA.res1<-permutationMultipleLm(fc=data2$fc, net=net2, 
#' # weights=data2$weights, num=1000))
#' # system.time( MGSEA.res2<-permutationMultipleLmMatrix(fc=data2$fc, 
#' # net=net2, weights=data2$weights, num=1000))
#' # head(MGSEA.res2)
#'
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#'
#' @seealso \code{\link{orderedIntersect}}; 
#' \code{\link{permutationMultipleLmMatrix}};
#'
permutationMultipleLm <- function( fc, net, weights=rep(1,nrow(net)), 
                                   num=100, verbose=TRUE )
{
    net <- as.matrix(net) # to transform the sparseMatrix to matrix
    shuffle <- lapply( seq_len(num), function(i) {
        if( verbose ) reportProgress(i,num,10)
        #randomfc <- rnorm(nrow(net))
        shuffledFC <- sample(fc,length(fc))
        shuffledLM <- lm( shuffledFC~net , weights=weights )
        p <- summary(shuffledLM)$coef[-1,4]
        f <- summary(shuffledLM)$fstatistic[1]
        list( p=p , f=f )
    } )
    shuffledPval <- do.call( cbind , lapply(shuffle,function(x) x$p ) )
    shuffledF    <- do.call(   c   , lapply(shuffle,function(x) x$f ) )
    trueLM <- lm( fc~net , weights=weights )
    observedCoef <- summary(trueLM)$coef[-1,-4]
    observedPval <- summary(trueLM)$coef[-1,4]
    observedF <- summary(trueLM)$fstatistic[1]
    
    empiricalPval <- vector("numeric", nrow(shuffledPval))
    for( i in seq_len(nrow(shuffledPval)) )
    {
        empiricalPval[i] <- mean( shuffledPval[i,]<observedPval[i] )
    }
    nonNaRange <- which( !is.na(trueLM$coefficients[-1]) )
    term <- colnames(net)[nonNaRange]
    usedGenes <- apply(as.matrix(net), 2, 
                      function(x) sum(x!=0,na.rm=TRUE) )[nonNaRange]
    # usedWeightedGenes = colSums( net*weights )
    pval <- data.frame(term,usedGenes,observedCoef,observedPval,empiricalPval)
    rownames(pval) = NULL
    pval <- pval[order(pval$empiricalPval),]
    fval <- c( f=observedF , f.pval=mean( shuffledF<observedF ) )
    #list( fval=fval , pval=pval )
    pval
}

#' permutationSimpleLmMatrix
#'
#' permutationSimpleLmMatrix is a permutation test to calculate the empirical p 
#' values for the weighted simple linear regression model based on the weighted 
#' Pearson correlation.
#'
#' @param fc a vector of numeric values representing the gene expression fold 
#' change
#' @param net a matrix of numeric values in the size of gene number x gene set 
#' number, representing the connectivity betwen genes and gene sets
#' @param weights a vector of numeric values representing the weights of 
#' permuted genes
#' @param num an integer value representing the number of permutations
#' @param step an integer value representing the number of permutations in 
#' each step 
#' @param verbose an boolean value indicating whether or not to print output to 
#' the screen 
#'
#' @return a data frame comprising following columns:
#' \itemize{
#' \item {term} a vector of character values incidating the name of gene set.
#' \item {usedGenes} a vector of numeric values indicating the number of gene 
#' used in the model.
#' \item {observedCorr} a vector of numeric values indicating the observed 
#' weighted Pearson correlation coefficients.
#' \item {empiricalPval} a vector of numeric values [0,1] indicating the 
#' permutation-based empirical p values. 
#' \item {BayesFactor} a vector of numeric values indicating the Bayes Factor 
#' for the multiple test correction.
#' }
#'
#' @export
#'
#' @importFrom stats lm pt qnorm
#' @importFrom utils read.table write.table
#' @importFrom Matrix sparseMatrix
#' @importFrom locfdr locfdr
#' @import MASS
#' 
#' @examples
#'
#' # load data
#' data(heart.metaXcan)
#' gene <- heart.metaXcan$gene_name
#'
#' # extract the imputed Z-score of gene differential expression, which follows 
#' # the normal distribution
#' fc <- heart.metaXcan$zscore
#'
#' # use as weights the prediction R^2 and the fraction of imputation-used SNPs 
#' usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
#' r2 <- heart.metaXcan$pred_perf_r2
#' weights <- usedFrac*r2
#'
#' # build a new data frame for the following weighted linear regression-based 
#' # enrichment analysis
#' data <- data.frame(gene,fc,weights)
#' head(data)
#'
#' net <- MSigDB.KEGG.Pathway$net
#'
#' # intersect the permuted genes with the gene sets of interest
#' data2 <- orderedIntersect( x = data , by.x = data$gene , 
#' by.y = rownames(net)  )
#' net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
#' by.y = data$gene  )
#' all( rownames(net2) == as.character(data2$gene) )
#'
#' # the SGSEA.res1 uses the weighted simple linear regression model, 
#' # while SGSEA.res2 used the weighted Pearson correlation. The latter one 
#' # takes substantially less time.
#' # system.time(SGSEA.res1<-permutationSimpleLm(fc=data2$fc, net=net2, 
#' # weights=data2$weights, num=1000))
#' system.time(SGSEA.res2<-permutationSimpleLmMatrix(fc=data2$fc, net=net2, 
#' weights=data2$weights, num=1000))
#' head(SGSEA.res2)
#'
#' @author Shijia Zhu, \email{shijia.zhu@@mssm.edu}
#'
#' @seealso \code{\link{orderedIntersect}}; \code{\link{permutationSimpleLm}};
#'
permutationSimpleLmMatrix <- function( fc, net, weights=rep(1,nrow(net)), 
                                      num=100, step=1000, verbose=TRUE )
{
    fc[is.na(fc)] <- 0
    weights[is.na(weights)] <- 0
    net <- as.matrix(net)
    net <- net[,colSums(net)>0]
    observedCorr <- weightedPearsonCorr( x=net, y=fc, w=weights )[,1]
    observedPval <- matrixPval( observedCorr, df=sum(weights>0, na.rm=TRUE)-2 )
    #observedPval2 <- separateLm( fc , net , weights )
    #max(abs(observedPval-observedPval2))
    
    empiricalSum <- rep(0,ncol(net))
    if( num%%step==0 )
    {
        steps <- rep(step,num%/%step)
    } else {
        steps <- c( rep(step,num%/%step) , num%%step )
    }
    cs_steps <- c( 1, cumsum(steps) )
    
    for( i in seq_along(steps) )
    {
        stepi <- steps[i]
        shuffledFC <- vapply( seq_len(stepi) , 
                             function(s) sample(fc) , numeric(length(fc)) )
        shuffledCorr <-  weightedPearsonCorr( x=net, y=shuffledFC, w=weights )
        
        for( j in seq_len(nrow(shuffledCorr)) )
        {
            if(observedCorr[j]>0) 
            {
                empiricalSum[j] <- empiricalSum[j] + 
                  sum(shuffledCorr > observedCorr[j])
            } else {
                empiricalSum[j] <- empiricalSum[j] + 
                  sum(shuffledCorr < observedCorr[j])
        }
        }
        
        for(j in cs_steps[i]:cs_steps[i+1]  ) 
        {
            if(verbose) reportProgress(j,num,10)
        }
    }
    
    term <- colnames(net)
    usedGenes <- apply(as.matrix(net), 2, function(x) sum(x!=0,na.rm=TRUE) )
    empiricalPval <- (empiricalSum+0.1)/(num*ncol(net))
    #lc <- locfdr( -1 * sign(observedCorr)*qnorm(empiricalPval) , plot=0 )
    #lc <- locfdr( observedCorr , plot=0 )
    zscore <- qnorm(empiricalPval)
    lc <- locfdr( c(zscore,-zscore) , plot=0 )
    localFdr <- lc$fdr[seq_along(zscore)]
    
    p0 <- lc$fp0[3,3]
    # p0 <- lc$fp0[3,3] - 1.96*lc$fp0[4,3]
    
    BayesFactor <- (1-localFdr)/localFdr *  p0/abs(1-p0)
    
    pval <- data.frame(term, usedGenes, observedCorr, empiricalPval, 
                       BayesFactor)
    rownames(pval) <- NULL
    #pval <- pval[order(pval$BayesFactor,decreasing=TRUE),]
    pval <- pval[order(pval$empiricalPval),]
    pval
    
}

## -----------------------------------------------------------------------------
library(GIGSEA)

## -----------------------------------------------------------------------------
# runGIGSEA( MetaXcan="software/MetaXcan.py" , 
# model_db_path="eQTL/DGN-WB_0.5.db", 
# covariance="reference/covariance.DGN-WB_0.5.txt.gz", 
# gwas_folder="data/GWAS_summary", gwas_file_pattern="heart.sumstats", 
# output_dir="result/GIGSEA", permutation_num=1000)

## -----------------------------------------------------------------------------
data(heart.metaXcan)
head(heart.metaXcan)

## -----------------------------------------------------------------------------
gene = heart.metaXcan$gene_name
# extract the imputed Z-score of differential gene expression, which follows 
# the normal distribution
fc <- heart.metaXcan$zscore
# use the prediction R^2 and fraction of imputation-used SNPs as weights 
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_model
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2
# build a new data frame for the following weighted linear regression-based 
# enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)

## -----------------------------------------------------------------------------
# load data
data(MSigDB.KEGG.Pathway)
# MSigDB.KEGG.Pathway is a list comprising two components: net and annot
class(MSigDB.KEGG.Pathway)
names(MSigDB.KEGG.Pathway)
dim(MSigDB.KEGG.Pathway$net)
# the column is the pathway and the row is the gene
head(colnames(MSigDB.KEGG.Pathway$net))
head(rownames(MSigDB.KEGG.Pathway$net))
# the annotation of the pathway
head(MSigDB.KEGG.Pathway$annot)
# the net takes discrete values of 0 or 1
head(MSigDB.KEGG.Pathway$net[,1:30])

## -----------------------------------------------------------------------------
# load data
data(TargetScan.miRNA)
# TargetScan.miRNA is a list comprising two components: net and annot
class(TargetScan.miRNA)
names(TargetScan.miRNA)
dim(TargetScan.miRNA$net)
# the column is the miRNA and the row is the gene
head(colnames(TargetScan.miRNA$net))
head(rownames(TargetScan.miRNA$net))
# the annotation of the miRNA
head(TargetScan.miRNA$annot)
# the net takes continuous values
head(TargetScan.miRNA$net[,1:20])

## -----------------------------------------------------------------------------
# downlaod the gmt file
gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
                        'single_drug_perturbations-v1.0.gmt') )
# obtain the index of up-regulated and down-regulated gene sets
index_up <- grep('-up',gmt)
index_down <- grep('-dn',gmt)
# transform the gmt file into gene sets. The gene set is a data frame, 
# comprising three vectors: term (here is drug), geneset (a gene symbol list 
# separated by comma), and value (1 and -1 separated by comma) 
gff_up <- gmt2geneSet( gmt[index_up] , termCol=c(1,2) , singleValue = 1 )
gff_down <- gmt2geneSet( gmt[index_down] , termCol=c(1,2) , singleValue = -1 )

# as following, combine the up and down-regulated gene sets together, 
# and use value of 1 and -1 to indicate their direction:
# extract the drug names
term_up <- sapply( gff_up$term , function(x) gsub('-up','',x) )
term_down <- sapply( gff_down$term , function(x) gsub('-dn','',x) )
all(term_up==term_down)
# combine up and down-regulated gene names for each drug perturbation
geneset <- sapply( 1:nrow(gff_up) , function(i) 
  paste(gff_up$geneset[i],gff_down$geneset[i],sep=',') )
# use 1 and -1 to indicate direction of up-regulated and down-regulated genes
value <- sapply( 1:nrow(gff_up) , function(i) 
  paste(gff_up$value[i],gff_down$value[i],sep=',') )
# transform the gene set into matrix, where the row represents the gene, 
# the column represents the drug perturbation, and each entry takes values of 
# 1 and -1
net1 <- geneSet2Net( term=term_up , geneset=geneset , value=value )
# transform the gene set into sparse matrix, where the row represents the gene,
# the column represents the drug perturbation, and each entry takes values of 
# 1 and -1
net2 <- geneSet2sparseMatrix( term=term_up , geneset=geneset , value=value )
tail(net1[,1:30])
tail(net2[,1:30])
# the size of sparse matrix is much smaller than the matrix
format( object.size(net1), units = "auto")
format( object.size(net2), units = "auto")

## -----------------------------------------------------------------------------
# take MSigDB.KEGG.Pathway as an example
net <- MSigDB.KEGG.Pathway$net
# intersect the permuted genes with the gene sets of interest
data2 <- orderedIntersect( x = data , by.x = data$gene , by.y = rownames(net) )
net2 <- orderedIntersect( x = net , by.x = rownames(net) , by.y = data$gene  )
all( rownames(net2) == as.character(data2$gene) )
# the SGSEA.res1 uses the weighted simple linear regression model, while 
# SGSEA.res2 used the weighted Pearson correlation. The latter one takes 
# substantially less time. 
system.time( SGSEA.res1 <- permutationSimpleLm( fc=data2$fc , net=net2 , 
                              weights=data2$weights , num=100 ) )
system.time( SGSEA.res2 <- permutationSimpleLmMatrix( fc=data2$fc , 
                              net=net2 , weights=data2$weights , num=100 ) )
head(SGSEA.res2)

## -----------------------------------------------------------------------------
# MGSEA.res1 uses the weighted multiple linear regression model 
system.time( MGSEA.res1 <- permutationMultipleLm( fc=data2$fc , net=net2 , 
                              weights=data2$weights , num=1000 ) )
# MGSEA.res2 used the matrix solution
system.time( MGSEA.res2 <- permutationMultipleLmMatrix( fc=data2$fc , 
                              net=net2 , weights=data2$weights , num=1000 ) )
head(MGSEA.res2)

## -----------------------------------------------------------------------------
# import packages and prepare data as above
library(GIGSEA)

# prepare the dataset
data(heart.metaXcan)
gene = heart.metaXcan$gene_name
fc <- heart.metaXcan$zscore
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2
data <- data.frame(gene,fc,weights)

# run one-step GIGSEA 
#weightedGSEA(data, geneCol='gene', fcCol='fc', weightCol= 'weights',
#geneSet=c("MSigDB.KEGG.Pathway","Fantom5.TF","TargetScan.miRNA","GO"), 
#permutationNum=10000, outputDir="./GIGSEA" )

#dir("./GIGSEA")

---
title: 'GIGSEA: Genotype Imputed Gene Set Enrichment Analysis'
author: |
  | Shijia Zhu
  | Department of Genetics and Genomic Sciences and Icahn Institute for Genomics and Multiscale Biology, Icahn School of Medicine at Mount Sinai, New York, NY 10029, USA
date: "August 28, 2017"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{GIGSEA: Genotype Imputed Gene Set Enrichment Analysis}
  %\VignetteEncoding{UTF-8}
output:
  pdf_document:
    toc: yes
    toc_depth: '3'
  html_document:
    highlight: tango
    theme: united
    toc: yes
    toc_depth: 3
---

## Abstract
We presented the Genotype Imputed Gene Set Enrichment Analysis (GIGSEA), a 
novel method that uses GWAS-and-eQTL-imputed differential gene expression to 
interrogate gene set enrichment for the trait-associated SNPs. By incorporating 
eQTL from large gene expression studies, e.g. GTEx, GIGSEA appropriately 
addresses such challenges for SNP enrichment as gene size, gene boundary, 
andmultiple-marker regulation. The weighted linear regression model, taking as 
weights both imputation accuracy and model completeness, was used to test the 
enrichment, properly adjusting the bias due to redundancy in different gene 
sets. The permutation test, furthermore, is used to evaluate the significance 
of enrichment, whose efficiency can be largely elevated by expressing the 
computational intensive part in terms of large matrix operation. We have shown 
the appropriate type I error rates for GIGSEA (<5%), and the preliminary 
results also demonstrate its good performance to uncover the real biological 
signal. 


## 1. Import packages
In GIGSEA, the gene sets are saved as matrices. Such matrices are largely 
sparse, so, in order to save space, we used the functions provided by the R 
package "Matrix" to build the sparse matrices and pre-saved into the GIGSEA 
package. In addition, GIGSEA uses the local fdr, implemented by the R package 
"locfdr", to adjust for multiple hypothesis testing.  

```{r}
library(GIGSEA)
```

## 2. Quick start
GIGSEA first uses MetaXcan (also called "s-predixcan") to impute 
trait-associated differential gene expression from both GWAS summary and eQTL 
database with LD structure adjusted, and next, builds a weighted regression 
model to perfrom gene set enrichment analysis. In user's convenience, we 
combine these procedures together into one function `runGIGSEA()`, which writes 
the enrichment test results at the local directory. Users only need to provide 
their GWAS summary data, and specify the paths to the MetaXcan.py file, the 
eQTL database (e.g. GTex and DGN) and the reference popultation (e.g. 1000 
Genome). 

```{r}
# runGIGSEA( MetaXcan="software/MetaXcan.py" , 
# model_db_path="eQTL/DGN-WB_0.5.db", 
# covariance="reference/covariance.DGN-WB_0.5.txt.gz", 
# gwas_folder="data/GWAS_summary", gwas_file_pattern="heart.sumstats", 
# output_dir="result/GIGSEA", permutation_num=1000)
```

Alternatively, users can also submit their GWAS summary data to the online 
version of MetaXcan (s-predixcan) <https://cloud.hakyimlab.org/s-predixcan> to 
impute the trait-associated differential gene expression, and next, run the 
following steps provided by GIGSEA to perform the gene set enrichment analysis 
for the trait-associated SNPs. 

***In case that users had neither installed MetaXcan nor run the online 
MetaXcan, an example of MetaXcan-imputed differential gene expression is given 
as follows. Users can use it to test the codes of GIGSEA step by step.

## 3. One example of MetaXcan output
MetaXcan integrates GWAS summary result with eQTL information to map 
trait-associated genes. See <https://github.com/hakyimlab/MetaXcan>. It 
provides a novel way to aggregate the multiple markers within each gene, 
address the long-range regulation, and adjust bias from gene boundaries and 
gene size. We use MetaXcan to impute the complex-trait-associated differential 
gene expression from eQTL summary and GWAS summary datasets. MetaXcan imputes 
~10,000 genes with high quality prediction in most tissues. The training 
dataset for the expression prediction or 1000 Genomes was used as reference 
population to address the LD structure (covariance) of markers. Users can also 
specify their own genotype data to address the LD structure. The eQTL summary 
data was pre-calculated from large gene expression studies, such as the 
Genotype-Tissue Expression Project (GTEx; a comprehensive set of tissues from 
of ~20,000 samples) (Lonsdale, et al., 2013) and Depression Genes and Networks 
(DGN; 922 whole-blood samples) (Battle, et al., 2014). So, users only need to 
provide the GWAS summary data to estimate the genetically regulated gene 
expression. 

We take as an example the cardiovascular disease (CVD) GWAS, CARDIoGRAMplusC4D 
(60,801 cases, 123,504 controls and 9.4M SNPs) (Nikpay, et al., 2015). The 
summary data is downloaded from <www.cardiogramplusc4d.org/data-downloads/>. We 
run the MetaXcan on it based on DGN eQTL database and 1000 Genomes as 
covariance. 

```{r}
data(heart.metaXcan)
head(heart.metaXcan)
```

Each row is a gene's association result:

- `gene`: a gene's id
- `gene_name`: a gene's name
- `zscore`: MetaXcan's association result for the gene
- `effect_size`: MetaXcan's association effect size for the gene
- `pvalue`: P-value of the aforementioned statistic
- `pred_perf_r2`: R2 of transcriptome prediction model's correlation to gene's 
measured transcriptome
- `pred_perf_pval`: pval of transcriptome prediction model's correlation to 
gene's measured transcriptome
- `pred_perf_qval`: qval of transcriptome prediction model's correlation to 
gene's measured transcriptome
- `n_snps_used`: number of snps from GWAS that got used in MetaXcan analysis
- `n_snps_in_cov`: number of snps in the covariance matrix
- `n_snps_in_model`: number of snps in the prediction model
- `var_g`: variance of the gene expression


We use the linear regression model to build a threshold-free gene set 
enrichment test, checking whether genes are significantly differentially 
expressed in a given gene set, as compared to the background. In the regression 
model, we regress the imputed Z-score of differential gene expression on the 
gene sets. However, the gene expression cannot be perfectly predicted using 
genotype, which is indicated by the prediction R^2, and moreover, not all SNPs 
in the prediction model are in user’s dataset. In order to take into account 
such two factors, we use as weights the multiplication of prediction R^2 and 
fraction of imputation-used SNPs, building a weighted linear regression model. 

```{r}
gene = heart.metaXcan$gene_name
# extract the imputed Z-score of differential gene expression, which follows 
# the normal distribution
fc <- heart.metaXcan$zscore
# use the prediction R^2 and fraction of imputation-used SNPs as weights 
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_model
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2
# build a new data frame for the following weighted linear regression-based 
# enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)
```


## 4. Load data of gene sets
GIGSEA is built on the weighted linear regression model, so it permits both 
discrete-valued and continuous-valued gene sets. We already incorporated 
several gene sets into the GIGSEA package, including:

1) **discrete-valued gene sets**:
- `MSigDB.KEGG.Pathway`: Gene sets derived from the KEGG pathway database. It 
comprises 186 pathways (column) and 5267 genes (row). 
See c2.cp.kegg.v6.0.symbols.gmt.txt at
<http://software.broadinstitute.org/gsea/msigdb/collections.jsp#C2> 
- `MSigDB.TF`: Gene sets that share upstream cis-regulatory motifs which can 
function as potential transcription factor binding sites. It comprises 615 TFs 
(column) and 12774 genes (row). See c3.tft.v6.0.symbols.gmt.txt at
<http://software.broadinstitute.org/gsea/msigdb/collections.jsp#C3> 
- `MSigDB.miRNA`: Gene sets that contain genes sharing putative target sites 
(seed matches) of human mature miRNA in their 3'-UTRs. It comprises 221 miRNAs 
(column) and 7444 genes (row). See c3.mir.v6.0.symbols.gmt.txt at
<http://software.broadinstitute.org/gsea/msigdb/collections.jsp#C3>
- `GO`: Gene sets that contain genes annotated by the same Gene Ontology (GO) 
term. For each GO term, we not only incorporate its own gene sets, but also 
incorporate the gene sets belonging to its offsprings. See the "database GO.db" 
in R. 

2) **continuous-valued gene sets**:
- `Fantom5.TF`: The human transcript promoter locations were obtained from 
Fantom5. Based on the promoter locations, the tool MotEvo was used to predict 
the human transcriptional factor (TF) target sites. The dataset contains 500 
Positional Weight Matrices (PWM) and 21964 genes. For each PWM, there is a list 
of associated human TFs, ordered by percent identity of TFs known to bind sites 
of the PWM. The list of associations was checked manually. The entire set of 
PWMs and mapping to associated TFs is available from the SwissRegulon website
<http://www.swissregulon.unibas.ch>.
- `TargetScan.miRNA`: Gene sets of predicted human miRNA target sites were 
downloaded from TargetScan. TargetScan groups miRNAs that have identical 
subsequences at positions 2 through 8 of the miRNA, i.e. the 2-7 seed region 
plus the 8th nucleotide, and provides predictions for each such seed motif. 
TargetScan covers 87 human miRNA seed motifs in total. It provides a score for 
each seed motif and each RefSeq transcript, called preferential conservation 
scoring (aggregate Pct), which shows consistently high performance in various 
benchmark tests. To obtain a site count associated with each gene, we average 
the TargetScan Pct scores of all RefSeq transcripts associated with each gene. 
It comprises 87 miRNA seed motifs and 9861 genes. 
See <http://www.targetscan.org>.
- `LINCS.CMap.drug`: Large perturbational datasets of gene expression signature 
from small-molecule compounds in multiple cell types from LINCS/CMap database. 
We downloaded the data of LINCS phase 2 level 5 from GEO (GSE70138). The data 
is saved in the GCTx format (binary format based on HDF5 that enables fast i/o 
than text), and we parsed it using the R package cmapR. The LINCS level 5 data 
is a numeric matrix, comprising 118050 drugs/doses and 12328 genes. Each entry 
is a replicate-collapsed z-score of differential gene expression due to a drug 
perturbation, which is calculated by aggregating across individual replicates. 
See <https://clue.io>. In order to generate a single signature for each drug 
perturbation, we further average the differential gene expression across 
different drug doses, resulting in a condensed matrix of 1826 drugs (column) 
and 12328 genes (row). 

### 4.1 Discrete-valued gene sets:
We first show an example of discrete-valued gene set: MSigDB.KEGG.Pathway, 
where the row represents the gene, and the column represents the pathway. Each 
entry takes discrete values of 0 or 1, where 1 represents the gene (row) 
belongs to the pathway (column), and otherwise, not.  
```{r}
# load data
data(MSigDB.KEGG.Pathway)
# MSigDB.KEGG.Pathway is a list comprising two components: net and annot
class(MSigDB.KEGG.Pathway)
names(MSigDB.KEGG.Pathway)
dim(MSigDB.KEGG.Pathway$net)
# the column is the pathway and the row is the gene
head(colnames(MSigDB.KEGG.Pathway$net))
head(rownames(MSigDB.KEGG.Pathway$net))
# the annotation of the pathway
head(MSigDB.KEGG.Pathway$annot)
# the net takes discrete values of 0 or 1
head(MSigDB.KEGG.Pathway$net[,1:30])
```


### 4.2 Continuous-valued gene sets:
Followed is an example of continuous-valued gene set: TargetScan.miRNA, where 
the row represents the gene, and the column represents the miRNA. Each entry 
takes continuous values of pct, representing the binding affinity of miRNA on 
the gene 3' UTR.   
```{r}
# load data
data(TargetScan.miRNA)
# TargetScan.miRNA is a list comprising two components: net and annot
class(TargetScan.miRNA)
names(TargetScan.miRNA)
dim(TargetScan.miRNA$net)
# the column is the miRNA and the row is the gene
head(colnames(TargetScan.miRNA$net))
head(rownames(TargetScan.miRNA$net))
# the annotation of the miRNA
head(TargetScan.miRNA$annot)
# the net takes continuous values
head(TargetScan.miRNA$net[,1:20])
```

### 4.3 User self-defined gene set
In adition to the above predefined gene sets, users can also specify their own 
gene set. Here, we take as an example the CREEDS <amp.pharm.mssm.edu/CREEDS/>. 
It is a manually curated database of gene signatures of single drug 
perturbations. For each drug perturbation, it lists both up-regulated and 
down-regulated gene sets. In the following example, we transform the gmt format 
file into a sparse matrix, where for each drug perturbation, the up-regulated 
genes take the value of 1, the down-regulated genes take the value of -1, and 
the others take the value of 0. 
```{r}
# downlaod the gmt file
gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
                        'single_drug_perturbations-v1.0.gmt') )
# obtain the index of up-regulated and down-regulated gene sets
index_up <- grep('-up',gmt)
index_down <- grep('-dn',gmt)
# transform the gmt file into gene sets. The gene set is a data frame, 
# comprising three vectors: term (here is drug), geneset (a gene symbol list 
# separated by comma), and value (1 and -1 separated by comma) 
gff_up <- gmt2geneSet( gmt[index_up] , termCol=c(1,2) , singleValue = 1 )
gff_down <- gmt2geneSet( gmt[index_down] , termCol=c(1,2) , singleValue = -1 )

# as following, combine the up and down-regulated gene sets together, 
# and use value of 1 and -1 to indicate their direction:
# extract the drug names
term_up <- sapply( gff_up$term , function(x) gsub('-up','',x) )
term_down <- sapply( gff_down$term , function(x) gsub('-dn','',x) )
all(term_up==term_down)
# combine up and down-regulated gene names for each drug perturbation
geneset <- sapply( 1:nrow(gff_up) , function(i) 
  paste(gff_up$geneset[i],gff_down$geneset[i],sep=',') )
# use 1 and -1 to indicate direction of up-regulated and down-regulated genes
value <- sapply( 1:nrow(gff_up) , function(i) 
  paste(gff_up$value[i],gff_down$value[i],sep=',') )
# transform the gene set into matrix, where the row represents the gene, 
# the column represents the drug perturbation, and each entry takes values of 
# 1 and -1
net1 <- geneSet2Net( term=term_up , geneset=geneset , value=value )
# transform the gene set into sparse matrix, where the row represents the gene,
# the column represents the drug perturbation, and each entry takes values of 
# 1 and -1
net2 <- geneSet2sparseMatrix( term=term_up , geneset=geneset , value=value )
tail(net1[,1:30])
tail(net2[,1:30])
# the size of sparse matrix is much smaller than the matrix
format( object.size(net1), units = "auto")
format( object.size(net2), units = "auto")
```


## 5. Gene set enrichment analysis
### 5.1 Gene set enrichment analysis using weighted simple linear regression
After obtaining the imputed differential gene expression and the weights, we 
build the weighted linear regression model to investigate the gene set 
enrichment. Permutation test was used to adjust the p values of the regression 
coefficients. We repeatedly shuffle the differential gene expression to obtain 
a global null distribution of no associated gene sets and calculate the 
empirical p value for each gene set. For the Single Gene Set Erichment Analysis 
(SGSEA), especially with many gene sets tested, a large number of weighted 
simple linear regression model would be interrogated. To improve the 
efficiency, we use weighted Pearson correlation to rank the significance, which
uses the same hypothesis statistic with the weighted linear regression model. 
Furthermore, we expressed it in terms of large matrix inner product, 
substantially improving the time efficiency. 

```{r}
# take MSigDB.KEGG.Pathway as an example
net <- MSigDB.KEGG.Pathway$net
# intersect the permuted genes with the gene sets of interest
data2 <- orderedIntersect( x = data , by.x = data$gene , by.y = rownames(net) )
net2 <- orderedIntersect( x = net , by.x = rownames(net) , by.y = data$gene  )
all( rownames(net2) == as.character(data2$gene) )
# the SGSEA.res1 uses the weighted simple linear regression model, while 
# SGSEA.res2 used the weighted Pearson correlation. The latter one takes 
# substantially less time. 
system.time( SGSEA.res1 <- permutationSimpleLm( fc=data2$fc , net=net2 , 
                              weights=data2$weights , num=100 ) )
system.time( SGSEA.res2 <- permutationSimpleLmMatrix( fc=data2$fc , 
                              net=net2 , weights=data2$weights , num=100 ) )
head(SGSEA.res2)
```

### 5.2 Gene set enrichment analysis using weighted multiple regression model
A gene may function in multiple ways and thus appear multiple times in 
functional gene sets. In spite of reflecting the crosstalk between gene sets, 
such overlap may make the results of gene set analysis more difficult to 
interpret.
To address the redundancy existing among gene sets, we build a weighted 
multiple linear regression model, taking into account all gene sets in one 
model. The redundancy of one gene set can be adjusted by considering all other 
gene sets as covariates. To improve the time efficiency, we also use matrix 
operation to solve the weighted multiple regression model.   

```{r}
# MGSEA.res1 uses the weighted multiple linear regression model 
system.time( MGSEA.res1 <- permutationMultipleLm( fc=data2$fc , net=net2 , 
                              weights=data2$weights , num=1000 ) )
# MGSEA.res2 used the matrix solution
system.time( MGSEA.res2 <- permutationMultipleLmMatrix( fc=data2$fc , 
                              net=net2 , weights=data2$weights , num=1000 ) )
head(MGSEA.res2)
```

### 5.3 One-step weightedGSEA
In user's convenience, we combine the above procedures together into one 
function `weightedGSEA()`. Based on the imputed differential gene expression, 
`weightedGSEA()` checks multiple classes of gene sets simultaneously and writes 
out the enrichment analysis results. Users need to provide the same data with 
above, and specify the columns of gene names (geneCol), imputed differential 
gene expression (fcCol), and weights (weightCol). Additionally, users specify 
the gene sets of interest (geneSet), the times of permutation (permutationNum) 
and the directory for saving the results (outputDir). By default, we only do 
SGSEA. Users can specify `MGSEAthres` to perform MGMEA for those with less than 
`MGSEAthres` gene sets. 

```{r}
# import packages and prepare data as above
library(GIGSEA)

# prepare the dataset
data(heart.metaXcan)
gene = heart.metaXcan$gene_name
fc <- heart.metaXcan$zscore
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2
data <- data.frame(gene,fc,weights)

# run one-step GIGSEA 
#weightedGSEA(data, geneCol='gene', fcCol='fc', weightCol= 'weights',
#geneSet=c("MSigDB.KEGG.Pathway","Fantom5.TF","TargetScan.miRNA","GO"), 
#permutationNum=10000, outputDir="./GIGSEA" )

#dir("./GIGSEA")
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TargetScan.miRNA}
\alias{TargetScan.miRNA}
\title{TargetScan.miRNA}
\format{A list with two items:
\describe{
  \item{net}{a sparse matrix, the connectivity between terms and genes, 
  comprising 87 miRNA seed motifs and 9861 genes}
  \item{annot}{a data frame, description of terms}
  ...
}}
\source{
\url{http://www.targetscan.org}
}
\usage{
TargetScan.miRNA
}
\description{
Gene sets of predicted human miRNA targets were obtained from TargetScan. 
TargetScan groups miRNAs that have identical subsequences at positions 2 
through 8 of the miRNA, i.e. the 2-7 seed region plus the 8th nucleotide, 
and provides predictions for each such seed motif.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weightedPearsonCorr.R
\name{weightedPearsonCorr}
\alias{weightedPearsonCorr}
\title{weightedPearsonCorr}
\usage{
weightedPearsonCorr(x, y, w = rep(1, nrow(x))/nrow(x))
}
\arguments{
\item{x}{a matrix of numeric values in the size of genes x featureA}

\item{y}{a matrix of numeric values in the size of genes x featureB}

\item{w}{a vector of numeric values indicating the weights of genes}
}
\value{
a matrix of numeric values in the size of featureA*featureB, 
indicating the weighted Pearson correlation coefficients
}
\description{
weightedPearsonCorr caculates the weighted Pearson correlation
}
\examples{


# load data
data(heart.metaXcan)
gene <- heart.metaXcan$gene_name

# extract the imputed Z-score of gene differential expression, which follows 
# the normal distribution
fc <- heart.metaXcan$zscore

# use as weights the prediction R^2 and fraction of imputation-used SNPs 
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2

# build a new data frame for the following weighted simple linear 
# regression-based enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)

net <- MSigDB.KEGG.Pathway$net

# intersect the imputed genes with the gene sets of interest
data2 <- orderedIntersect( x = data , by.x = data$gene , 
by.y = rownames(net)  )
net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
by.y = data$gene  )
all( rownames(net2) == as.character(data2$gene) )

# calculate the weighted Pearson correlation
observedCorr = weightedPearsonCorr( x=net2 , y=data2$fc, w=data2$weights )

# calculate the p values of the weighted Pearson correlation
observedPval = matrixPval( observedCorr, df=sum(weights>0,na.rm=TRUE)-2 )

res = data.frame( observedCorr , observedPval )
head(res)

}
\seealso{
\code{\link{orderedIntersect}}; \code{\link{matrixPval}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matrixPval.R
\name{matrixPval}
\alias{matrixPval}
\title{matrixPval}
\usage{
matrixPval(r, df)
}
\arguments{
\item{r}{a vector or a matrix of Pearson correlation coefficients taking 
values in [-1,+1]}

\item{df}{the degree of freedom}
}
\value{
a vector or matrix of p values taking values in [0,1]
}
\description{
matrixPval calculates the p values for the correlation coefficients based on 
t-statistics
}
\examples{


r <- cor(USArrests)
df <- nrow(USArrests) - 2
pval1 <- matrixPval(r,df)

pval2 <- matrix(ncol=ncol(USArrests),nrow=ncol(USArrests),data=0)
for(i in 1:ncol(USArrests))
{
   for(j in 1:ncol(USArrests))
   {
     pval2[i,j] <- cor.test(USArrests[,i],USArrests[,j])$p.val
   }
}

head(pval1)
head(pval2)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/runGIGSEA.R
\name{runGIGSEA}
\alias{runGIGSEA}
\title{runGIGSEA}
\usage{
runGIGSEA(MetaXcan, model_db_path, covariance, gwas_folder, gwas_file_pattern,
  snp_column = "SNP", non_effect_allele_column = "A2",
  effect_allele_column = "A1", or_column = "OR", beta_column = "BETA",
  beta_sign_column = "direction", zscore_column = "Z",
  pvalue_column = "P", gene_set = c("MSigDB.KEGG.Pathway", "MSigDB.TF",
  "MSigDB.miRNA", "TargetScan.miRNA"), permutation_num = 1000,
  output_dir = "./GIGSEA", MGSEA_thres = NULL, verbose = TRUE)
}
\arguments{
\item{MetaXcan}{a character value indicating the path to the MetaXcan.py 
file.}

\item{model_db_path}{a character value indicating the path to tissue 
transriptome model.}

\item{covariance}{a character value indicating the path to file containing 
covariance information. This covariance should have information related to 
the tissue transcriptome model.}

\item{gwas_folder}{a character value indicating the folder containing GWAS 
summary statistics data.}

\item{gwas_file_pattern}{a regular expression indicating the gwas summary 
files.}

\item{snp_column}{a character value indicating the name of column holding 
SNP data, by default, "SNP".}

\item{non_effect_allele_column}{a character value indicating the name of 
column holding "other/non effect" allele data, by default, "A2".}

\item{effect_allele_column}{a character value indicating the name of column 
holding effect allele data, by default, "A1".}

\item{or_column}{a character value indicating the name of column holding Odd 
Ratio data, by default, "OR".}

\item{beta_column}{a character value indicating the name of column holding 
beta data, by default, "BETA".}

\item{beta_sign_column}{a character value indicating the name of column 
holding sign of beta, by default, "direction".}

\item{zscore_column}{a character value indicating the name of column holding 
zscore of beta, by default, "Z".}

\item{pvalue_column}{a character value indicating the name of column holding 
p-values data, by default, "P".}

\item{gene_set}{a vector of characters indicating the gene sets of interest 
for enrichment test, by default, c("MSigDB.KEGG.Pathway","MSigDB.TF",
"MSigDB.miRNA","Fantom5.TF","TargetScan.miRNA","GO", "LINCS.CMap.drug")}

\item{permutation_num}{an integer indicating the number of permutation.}

\item{output_dir}{a character value indicating the directory for saving the 
results.}

\item{MGSEA_thres}{an integer value indicating the thresfold for performing 
MGSEA. When the number of gene sets is smaller than MGSEAthres, we perform 
MGSEA.}

\item{verbose}{an boolean value indicating whether or not to print output to 
the screen}
}
\value{
TRUE
}
\description{
runGIGSEA use MetaXcan to impute the trait-associated differential gene 
expression from GWAS summary and eQTL database first, and next, performs 
gene set enrichment analysis for the trait-associated SNPs.
}
\examples{
# runGIGSEA( MetaXcan="/MetaXcan/software/MetaXcan.py" , 
  # model_db_path="data/DGN-WB_0.5.db" ,
  # covariance="data/covariance.DGN-WB_0.5.txt.gz" ,
  # gwas_folder="data/GWAS" ,
  # gwas_file_pattern="heart.summary" ,
  # zscore_column="Z" ,
  # output_dir="./GIGSEA",
  # permutation_num=1000)
 
}
\references{
Barbeira, A., et al. Integrating tissue specific mechanisms into GWAS 
summary results. bioRxiv 2016:045260.
https://github.com/hakyimlab/MetaXcan
}
\seealso{
\code{\link{weightedGSEA}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneSet2sparseMatrix.R
\name{geneSet2sparseMatrix}
\alias{geneSet2sparseMatrix}
\title{geneSet2sparseMatrix}
\usage{
geneSet2sparseMatrix(term, geneset, value = NULL, sep = ",")
}
\arguments{
\item{term}{a vector of character values incidating the names of gene sets, 
e.g., pathway names and miRNA names.}

\item{geneset}{a vector of character values, where each value is a gene list 
separated by 'sep'.}

\item{value}{a vector of numeric values indicating the connectivity of 
between terms and genes. It could take either discrete values (0 and 1) or 
continuous values.}

\item{sep}{a character which separates the genes in the geneset.}
}
\value{
a sparse matrix where the column corresponds to the term and the row 
corresponds to the geneset.
}
\description{
geneSet2sparseMatrix transforms gene sets to a sparse matrix, which 
represents the connectivity between terms and genes.
}
\examples{

# download the gmt file
gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
'single_drug_perturbations-v1.0.gmt') ) 

# obtain the index of up-regulated and down-regulated gene sets
index_up <- grep('-up',gmt)
index_down <- grep('-dn',gmt)

# transform the gmt file into gene sets. The gene set is a data frame, 
# comprising three vectors: 
# term (here is drug), geneset (a gene symbol list separate by comma), 
# and value (1 and -1 separate by comma)
gff_up <- gmt2geneSet( gmt[index_up], termCol=c(1,2), singleValue = 1 )
gff_down <- gmt2geneSet( gmt[index_down], termCol=c(1,2), singleValue = -1 )

# combine up and down-regulated gene sets, and use 1 and -1 to indicate 
# their direction 
# extract the drug names
term_up<-vapply(gff_up$term, function(x) gsub('-up','',x), character(1))
term_down<-vapply(gff_down$term, function(x) gsub('-dn','',x), character(1))
all(term_up==term_down)

# combine the up-regulated and down-regulated gene names for each 
# drug perturbation
geneset <- vapply(1:nrow(gff_up),function(i) paste(gff_up$geneset[i],
gff_down$geneset[i],sep=','), character(1) )

# use 1 and -1 to indicate the direction of up and down-regulated genes
value <- vapply( 1:nrow(gff_up) , function(i) paste(gff_up$value[i],
gff_down$value[i],sep=',') , character(1) )


# transform the gene set into matrix, where the row represents the gene, 
# the column represents the drug perturbation, and each entry takes values 
# of 1 and -1
net1 <- geneSet2Net( term=term_up , geneset=geneset , value=value )
# transform the gene set into sparse matrix, where the row represents the 
# gene, the column represents the drug perturbation, and each entry takes 
# values of 1 and -1
net2 <- geneSet2sparseMatrix( term=term_up , geneset=geneset , value=value )
tail(net1[,1:30])
tail(net2[,1:30])
# the size of sparse matrix is much smaller than the matrix
format( object.size(net1), units = "auto")
format( object.size(net2), units = "auto")

}
\seealso{
\code{\link{gmt2geneSet}}; \code{\link{geneSet2Net}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutationSimpleLmMatrix.R
\name{permutationSimpleLmMatrix}
\alias{permutationSimpleLmMatrix}
\title{permutationSimpleLmMatrix}
\usage{
permutationSimpleLmMatrix(fc, net, weights = rep(1, nrow(net)), num = 100,
  step = 1000, verbose = TRUE)
}
\arguments{
\item{fc}{a vector of numeric values representing the gene expression fold 
change}

\item{net}{a matrix of numeric values in the size of gene number x gene set 
number, representing the connectivity betwen genes and gene sets}

\item{weights}{a vector of numeric values representing the weights of 
permuted genes}

\item{num}{an integer value representing the number of permutations}

\item{step}{an integer value representing the number of permutations in 
each step}

\item{verbose}{an boolean value indicating whether or not to print output to 
the screen}
}
\value{
a data frame comprising following columns:
\itemize{
\item {term} a vector of character values incidating the name of gene set.
\item {usedGenes} a vector of numeric values indicating the number of gene 
used in the model.
\item {observedCorr} a vector of numeric values indicating the observed 
weighted Pearson correlation coefficients.
\item {empiricalPval} a vector of numeric values [0,1] indicating the 
permutation-based empirical p values. 
\item {BayesFactor} a vector of numeric values indicating the Bayes Factor 
for the multiple test correction.
}
}
\description{
permutationSimpleLmMatrix is a permutation test to calculate the empirical p 
values for the weighted simple linear regression model based on the weighted 
Pearson correlation.
}
\examples{

# load data
data(heart.metaXcan)
gene <- heart.metaXcan$gene_name

# extract the imputed Z-score of gene differential expression, which follows 
# the normal distribution
fc <- heart.metaXcan$zscore

# use as weights the prediction R^2 and the fraction of imputation-used SNPs 
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2

# build a new data frame for the following weighted linear regression-based 
# enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)

net <- MSigDB.KEGG.Pathway$net

# intersect the permuted genes with the gene sets of interest
data2 <- orderedIntersect( x = data , by.x = data$gene , 
by.y = rownames(net)  )
net2 <- orderedIntersect( x = net , by.x = rownames(net) , 
by.y = data$gene  )
all( rownames(net2) == as.character(data2$gene) )

# the SGSEA.res1 uses the weighted simple linear regression model, 
# while SGSEA.res2 used the weighted Pearson correlation. The latter one 
# takes substantially less time.
# system.time(SGSEA.res1<-permutationSimpleLm(fc=data2$fc, net=net2, 
# weights=data2$weights, num=1000))
system.time(SGSEA.res2<-permutationSimpleLmMatrix(fc=data2$fc, net=net2, 
weights=data2$weights, num=1000))
head(SGSEA.res2)

}
\seealso{
\code{\link{orderedIntersect}}; \code{\link{permutationSimpleLm}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dataframe2geneSet.R
\name{dataframe2geneSet}
\alias{dataframe2geneSet}
\title{dataframe2geneSet}
\usage{
dataframe2geneSet(term, gene, value = NULL)
}
\arguments{
\item{term}{a character value incidating the name of the column for the 
gene set (terms).}

\item{gene}{a character value incidating the name of the column for the 
genes.}

\item{value}{a vector of numeric values indicating the connectivity of 
between terms and genes. It could take either discrete values (0 and 1) 
or continuous values.}
}
\value{
a data frame, comprising three vectors: term (like pathway names), 
geneset (a gene symbol list separate by comma), and value (either discrete 
or continuous separated by comma)
}
\description{
dataframe2geneSet transforms a data frame (1term-1gene) into geneSets 
(1term-Ngenes).
}
\seealso{
\code{\link{geneSet2Net}}; \code{\link{geneSet2sparseMatrix}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/orderedIntersect.R
\name{orderedIntersect}
\alias{orderedIntersect}
\title{orderedIntersect}
\usage{
orderedIntersect(x, by.x, by.y)
}
\arguments{
\item{x}{a data frame}

\item{by.x}{a vector of character values. The data frame is sorted based on 
by.x}

\item{by.y}{a vector of character values. After being sorted, the rows of x 
are further filtered by intersecting by.x with by.y}
}
\value{
a data frame sorted by "by.x" and intersected with "by.y"
}
\description{
orderedIntersect sorts a data frame based on a given collumn and intersects 
with another vector.
}
\examples{


# load data
data(heart.metaXcan)
gene <- heart.metaXcan$gene_name

# extract the imputed Z-score of gene differential expression, which follows 
# normal distribution
fc <- heart.metaXcan$zscore

# use the prediction R^2 and fraction of imputation-used SNPs as weights
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2

# build a new data frame for the following weighted linear regression-based 
# enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)

net <- MSigDB.KEGG.Pathway$net

# intersect the user-provided imputed genes with the gene set of interest
data2 <- orderedIntersect( x=data, by.x=data$gene, by.y=rownames(net) )
net2 <- orderedIntersect( x=net, by.x=rownames(net), by.y=data$gene )
all( rownames(net2) == as.character(data2$gene) )

}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MSigDB.TF}
\alias{MSigDB.TF}
\title{MSigDB.TF}
\format{A list with two items:
\describe{
  \item{net}{a sparse matrix, the connectivity between terms and genes, 
  comprising 615 TFs (column) and 12774 genes (row)}
  \item{annot}{a data frame, description of terms}
  ...
}}
\source{
\url{software.broadinstitute.org/gsea/msigdb/collections.jsp#C3}
}
\usage{
MSigDB.TF
}
\description{
Gene sets that share upstream cis-regulatory motifs which can function as 
potential transcription factor binding sites.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MSigDB.miRNA}
\alias{MSigDB.miRNA}
\title{MSigDB.miRNA}
\format{A list with two items:
\describe{
  \item{net}{a sparse matrix, the connectivity between terms and genes, 
  comprising 221 miRNAs (column) and 7444 genes (row)}
  \item{annot}{a data frame, description of terms}
  ...
}}
\source{
\url{software.broadinstitute.org/gsea/msigdb/collections.jsp#C3}
}
\usage{
MSigDB.miRNA
}
\description{
Gene sets that contain genes sharing putative target sites (seed matches) 
of human mature miRNA in their 3'-UTRs.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/weightedGSEA.R
\name{weightedGSEA}
\alias{weightedGSEA}
\title{weightedGSEA}
\usage{
weightedGSEA(data, geneCol, fcCol, weightCol = NULL,
  geneSet = c("MSigDB.KEGG.Pathway", "MSigDB.TF", "MSigDB.miRNA",
  "TargetScan.miRNA"), permutationNum = 100, outputDir = getwd(),
  MGSEAthres = NULL, verbose = TRUE)
}
\arguments{
\item{data}{a data frame comprising comlumns: gene names (characer), 
differential gene expression (numeric) and permuated gene weights (numeric 
and optional)}

\item{geneCol}{an integer or a character value indicating the column of gene 
name}

\item{fcCol}{an integer or a character value indicating the column of 
differential gene expression}

\item{weightCol}{an integer or a character value indicating the column of 
gene weights}

\item{geneSet}{a vector of character values indicating the gene sets of 
interest.}

\item{permutationNum}{an integer value indicating the number of permutation}

\item{outputDir}{a character value indicating the directory for saving the 
results}

\item{MGSEAthres}{an integer value indicating the thresfold for MGSEA. MGSEA 
is performed with no more than "MGSEAthres" gene sets}

\item{verbose}{an boolean value indicating whether or not to print output to 
the screen}
}
\value{
TRUE
}
\description{
weightedGSEA performs both SGSEA and MGSEA for a given list of gene sets, 
and writes out the results.
}
\examples{

data(heart.metaXcan)
gene <- heart.metaXcan$gene_name
fc <- heart.metaXcan$zscore
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2
data <- data.frame(gene,fc,weights)
# run one-step GIGSEA 
# weightedGSEA(data, geneCol='gene', fcCol='fc', weightCol= 'weights', 
#    geneSet=c("MSigDB.KEGG.Pathway","MSigDB.TF","MSigDB.miRNA",
# "TargetScan.miRNA"), permutationNum=10000, outputDir="./GIGSEA" )
# dir("./GIGSEA")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/permutationMultipleLmMatrix.R
\name{permutationMultipleLmMatrix}
\alias{permutationMultipleLmMatrix}
\title{permutationMultipleLmMatrix}
\usage{
permutationMultipleLmMatrix(fc, net, weights = rep(1, nrow(net)), num = 100,
  step = 1000, verbose = TRUE)
}
\arguments{
\item{fc}{a vector of numeric values representing gene expression fold 
change}

\item{net}{a matrix of numeric values in the size of gene number x gene set 
number, representing the connectivity between genes and gene sets}

\item{weights}{a vector of numeric values representing the weights of 
permuated genes}

\item{num}{an integer value representing the number of permutations}

\item{step}{an integer value representing the number of permutations in 
each step}

\item{verbose}{an boolean value indicating whether or not to print output to 
the screen}
}
\value{
a data frame comprising following columns:
\itemize{
\item {term} a vector of character values incidating the names of gene sets.
\item {usedGenes} a vector of numeric values indicating the number of genes 
used in the model.
\item {observedTstats} a vector of numeric values indicating the observed 
t-statistics for the weighted multiple regression coefficients.
\item {empiricalPval} a vector of numeric values [0,1] indicating the 
permutation-based empirical p values.
\item {BayesFactor} a vector of numeric values indicating the Bayes Factor 
for the multiple test correction.
}
}
\description{
permutationMultipleLmMatrix is a permutation test to calculate the empirical
p values for weighted multiple linear regression
}
\examples{

# load data
data(heart.metaXcan)
gene <- heart.metaXcan$gene_name

# extract the imputed Z-score of differential gene expression, which 
# follows the normal distribution
fc <- heart.metaXcan$zscore

# use as weights the prediction R^2 and the fraction of imputation-used SNPs 
usedFrac <- heart.metaXcan$n_snps_used / heart.metaXcan$n_snps_in_cov
r2 <- heart.metaXcan$pred_perf_r2
weights <- usedFrac*r2

# build a new data frame for the following weighted linear regression-based 
# enrichment analysis
data <- data.frame(gene,fc,weights)
head(data)

net <- MSigDB.KEGG.Pathway$net

# intersect the imputed genes with the gene sets of interest
data2 <- orderedIntersect( x=data, by.x=data$gene, by.y=rownames(net))
net2 <- orderedIntersect( x=net, by.x=rownames(net), by.y=data$gene)
all( rownames(net2) == as.character(data2$gene) )

# the MGSEA.res1 uses the weighted multiple linear regression to do 
# permutation test, 
# while MGSEA.res2 used the solution of weighted matrix operation. The 
# latter one takes substantially less time.
# system.time( MGSEA.res1<-permutationMultipleLm(fc=data2$fc, net=net2, 
# weights=data2$weights, num=1000))
system.time( MGSEA.res2<-permutationMultipleLmMatrix(fc=data2$fc, net=net2, 
weights=data2$weights, num=1000))
head(MGSEA.res2)

}
\seealso{
\code{\link{orderedIntersect}}; 
\code{\link{permutationMultipleLm}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{heart.metaXcan}
\alias{heart.metaXcan}
\title{heart.metaXcan}
\format{A data frame with the following items:
\describe{
  \item{gene}{a gene's id}
  \item{gene_name}{a gene's name}
  \item{zscore}{MetaXcan's association result for the gene}
  \item{effect_size}{MetaXcan's association effect size for the gene}
  \item{pvalue}{P-value of the aforementioned statistic}
  \item{pred_perf_r2}{R2 of transcriptome prediction model's correlation 
  to gene's measured transcriptome}
  \item{pred_perf_pval}{pval of transcriptome prediction model's correlation 
  to gene's measured transcriptome}
  \item{pred_perf_qval}{qval of transcriptome prediction model's correlation 
  to gene's measured transcriptome}
  \item{n_snps_used}{number of snps from GWAS that got used in MetaXcan 
  analysis}
  \item{n_snps_in_cov}{number of snps in the covariance matrix}
  \item{n_snps_in_model}{number of snps in the prediction model}
  \item{var_g}{variance of the gene expression}
  ...
}}
\source{
\url{http://www.cardiogramplusc4d.org/data-downloads/;
https://cloud.hakyimlab.org/s-predixcan}
}
\usage{
heart.metaXcan
}
\description{
The MetaXcan-predicted differential gene expression from the cardiovascular 
disease (CVD) GWAS, CARDIoGRAMplusC4D (60,801 cases, 123,504 controls and 
9.4M SNPs).
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gmt2geneSet.R
\name{gmt2geneSet}
\alias{gmt2geneSet}
\title{gmt2geneSet}
\usage{
gmt2geneSet(gmt, termCol = 1, nonGeneCol = termCol, singleValue = NULL)
}
\arguments{
\item{gmt}{a vector of character values. Each item is a list of words 
comprising a term and its corresponding gene set, which are separated by tab.}

\item{termCol}{an integer value indicating in each item of gmt, which word 
is the term , by default, 1.}

\item{nonGeneCol}{an integer value indicating in each item of gmt, which 
words are not the gene set, by default, termCol.}

\item{singleValue}{a numeric value, which assigns the same value to all 
genes in a given gene set. This is useful when combining together the 
up-regulated gene sets (regularly, singleValue=1) and the down-regulated 
gene sets (regularly, singleValue=-1)}
}
\value{
a data frame, comprising three vectors: term (like pathway names), 
geneset (a gene symbol list separate by comma), and value (either discrete 
or continuous separated by comma)
}
\description{
gmt2geneSet transforms a gmt format file into geneSets.
}
\examples{

# download the gmt file
gmt <- readLines( paste0('http://amp.pharm.mssm.edu/CREEDS/download/',
'single_drug_perturbations-v1.0.gmt') ) 

# obtain the index of up-regulated and down-regulated gene sets
index_up <- grep('-up',gmt)
index_down <- grep('-dn',gmt)

# transform the gmt file into gene sets. The gene set is a data frame, 
# comprising three vectors: 
# term (here is drug), geneset (a gene symbol list separate by comma), 
# and value (1 and -1 separate by comma)
gff_up <- gmt2geneSet( gmt[index_up], termCol=c(1,2), singleValue = 1 )
gff_down <- gmt2geneSet( gmt[index_down], termCol=c(1,2), singleValue = -1 )


}
\seealso{
\code{\link{geneSet2Net}}; \code{\link{geneSet2sparseMatrix}};
}
\author{
Shijia Zhu, \email{shijia.zhu@mssm.edu}
}
